<?php
 
class NP_MagicalURL extends NucleusPlugin
{
    function getName()  { return 'MagicalURL'; }
    function getAuthor() { return 'nakahara21+fujisaki'; }
    function getURL()     { return 'http://nakahara21.com'; }
    function getVersion() { return '0.6'; }
    function getMinNucleusVersion() { return 322; }
	function getMinNucleusPatchLevel() { return 0; }
    function getDescription() {
        return 'Replaces the /item/1234 URLs by /item_1234.html.';
    }
 
	function supportsFeature($what) 
	{
		switch ($what)
		{
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}
		
	function init()
	{
		$this->ext = '.html';
	}
	
    function getEventList() 
    {
    	return array('GenerateURL');
    }
	
	function event_GenerateURL(&$data)
	{
		// if another plugin already generated the URL
		if ($data['completed'])
			return;
			
		global $CONF,$manager;
		
		$params = $data['params'];
		
			
		switch ($data['type'])
		{
			case 'item':
				$baseurl = $CONF['ItemURL'] . '/' . $CONF['ItemKey'] . '_' . $params['itemid'];
				break;

			case 'archive':
				$baseurl = $CONF['ArchiveURL'] . '/' . $CONF['ArchiveKey'] . '_' . $params['blogid']. '_' . $params['archive'];
				break;

			case 'archivelist':
				if (!$params['blogid'])
					$params['blogid'] = $CONF['DefaultBlog'];
				$baseurl = $CONF['ArchiveListURL'] . '/' . $CONF['ArchivesKey'] . '_' . $params['blogid'];
				break;

			case 'category':
				$baseurl = $CONF['CategoryURL'] . '/' . $CONF['CategoryKey'] . '_' . $params['catid'];
				break;

			case 'blog':
				$baseurl = $CONF['BlogURL'] . '/' . $CONF['BlogKey'] . '_' . $params['blogid'];
				break;

			case 'member':
				$baseurl = $CONF['Self'] . '/' . $CONF['MemberKey'] . '_' . $params['memberid'];
				break;
		}
		if($baseurl){
				$data['url'] = $this->_addLinkParams($baseurl, $params['extra']). $this->ext;
				$data['completed'] = true;
				return;
		}

	}

	function _addLinkParams($link, $params) {
		global $CONF;
		if (is_array($params)) {
			foreach ($params as $param => $value) {
//				$link .= '/' . $param . '/' . urlencode($value);
				$link .= '_' . $param . '_' . urlencode($value);
			}
		}
		if(strstr ($link, '//')){ $link = preg_replace("/([^:])\/\//", "$1/", $link);}
		return $link;
	}
 
}
?>